#include <Wire.h>
#include <LIS3MDL.h>

LIS3MDL mag;
//min: { -3583,  -6447,   -266}   max: { +6024,  +2343,  +9723}

    const float xmin = -3583;
    const float ymin = -6447;
    const float zmin = -266;
    const float xmax = 6024;
    const float ymax = 2343;
    const float zmax = 9723;
    const float xmove = xmax-xmin;
    const float ymove = ymax-ymin;
    const float zmove = zmax-zmin;
    const float xoff = (xmax+xmin)/2;
    const float yoff = (ymax+ymin)/2;
    const float zoff = (zmax+zmin)/2;
    const float delt_x = xmove/2;
    const float delt_y = ymove/2;
    const float delt_z = zmove/2;
    const float delt = (delt_x + delt_y + delt_z)/3;
    const float magScale_X = delt_x/delt;
    const float magScale_Y = delt_y/delt;
    const float magScale_Z = delt_z/delt;
    const float magGain = 6842;
char report[80];

void setup()
{
  Serial.begin(9600);
  Wire.begin();

  if (!mag.init())
  {
    Serial.println("Failed to detect and initialize magnetometer!");
    while (1);
  }

  mag.enableDefault();
  //mag.m_min = (LIS3MDL::vector<int16_t>){xmin, ymin, zmin};
  //mag.m_max = (LIS3MDL::vector<int16_t>){xmax, ymax, zmax};
}

void loop()
{
  mag.read();
  float xval = (float)(mag.m.x - xoff)* magScale_X / magGain;
  float yval = (float)(mag.m.y - yoff)* magScale_Y / magGain;
  float zval = (float)(mag.m.z - zoff)* magScale_Z / magGain;
  float magAll = sqrt(xval*xval + yval*yval+zval*zval);
  
  float xV = (float)(mag.m.x)/magGain;
  float yV = (float)(mag.m.y)/magGain;
  float zV = (float)(mag.m.z)/magGain;
  float magA = sqrt(xV*xV+yV*yV*zV*zV);
  
  snprintf(report, sizeof(report), "{x, y, z} {%+6f, %+6f, %+6f} mag {%+6f}",
    xval,yval,zval, magAll);
    //xV, yV, zV, magZ);
    
  Serial.println(report);

  delay(1000);
}
